﻿
#cs

get yahoogroup mails.au3
Samuel Murray

Initial idea:
http://www.usenix.org.uk/content/yahoo_mbox.html
(seen on the OmegaTDev mailing list)

You also need:
* curl for Windows
* Firefox

Install this extension for Firefox:
https://addons.mozilla.org/en-US/firefox/addon/export-cookies/?src=api

Then log in to Yahoogroups with Firefox to create a cookie.  Then export your cookies to e.g. "cookies.txt".  Optionally, remove all lines that do not begin with "yahoo.com", but I think it's safe to use the entire cookie file.

The script needs curl.exe in the same folder as the script, and also the cookies file.

The script attempts to check every 10 messages if Yahoogroups has stopped sending actual messages, but it's not guaranteed to work.

#ce

; $groupname = Your Yahoogroup's name
; $totalmsg = Total number of messages
; $startmsg = Start at which number
; $numtodo = How many messages to get

$groupname = "omegat"
$totalmsg = 40000
$startmsg = 1
$numtodo = 10000

For $i = $startmsg to $numtodo

$j = $i
If $i < 100000 Then
$j = "0" & $j
EndIf
If $i < 10000 Then
$j = "0" & $j
EndIf
If $i < 1000 Then
$j = "0" & $j
EndIf
If $i < 100 Then
$j = "0" & $j
EndIf
If $i < 10 Then
$j = "0" & $j
EndIf

RunWait(@ComSpec & " /c curl -b cookies.txt -4 https://groups.yahoo.com/api/v1/groups/" & $groupname & "/messages/" & $i & "/raw > msg" & $j & ".txt", "", @SW_HIDE) 

; check every 10 messages for error 999 (means users is blocked for a while)

If $i = (Int ($i / 10) * 10) Then
$checkmsg = FileRead (FileOpen ("msg" & $j & ".txt", 128))
If StringInStr ($checkmsg, 'Unable to process request at this time') Then
RunWait(@ComSpec & ' /c Notepad.exe "msg' & $j & '.txt"')
MsgBox (0, "Yahoo says 'Unable to process request at this time'", "Check if the last few messages were all error messages from Yahoo, and if so, stop the script (right-click the icon in the systray), and find/delete all downloaded files that contain this error message, to determine the last good download.", 0)
EndIf
EndIf

; check every 50 messages for empty messages (could simply mean there's no such message)

If $i = (Int ($i / 50) * 50) Then
$checkmsg = FileRead (FileOpen ("msg" & $j & ".txt", 128))
If NOT (StringInStr ($checkmsg, '","rawEmail":"')) Then
RunWait(@ComSpec & ' /c Notepad.exe "msg' & $j & '.txt"')
MsgBox (0, "Curl response does not contain message", "Check if the last few messages were all 'empty' (i.e. less than 3 KB), and if so, stop the script (right-click the icon in the systray).", 20)
EndIf
EndIf

If $i = (Int ($i / 100) * 100) Then
TrayTip ("", "Downloaded " & $i & " out of " & $numtodo & @CRLF & "(out of " & $totalmsg & " grand total)", 30)
EndIf

Next

